<template>
    <tr>
        <td class="text-center">
            <input type="hidden" v-model="row.sn"><span v-text="row.sn"></span>
        </td>
        <td>
            <input type="text" class="field" v-model="row.particular">
        </td>
        <td>
            <input type="text" @keypress="numberOnly" class="field right" v-model="row.quantity">
        </td>
        <td>
            <input type="text" @keypress="numberOnly" class="field right" v-model="row.rate">
        </td>
        <td class="text-right">
            <span v-text="row.total.toLocaleString(undefined, { minimumFractionDigits: 2 })"></span>
        </td>
        <td>
            <span v-if="index > 0" class="btn btn-block btn-danger btn-xs" @click="$emit('delete')">
                <i class="fa fa-times"></i>
            </span>
        </td>
    </tr>
</template>

<script type="text/ecmascript-6">
    export default {
        name: "InvoiceDetail",

        props: {
            value: {required: true, type: Object},
            index: {required: true, type: Number},
        },

        data() {
            return {
                row: {
                    sn: 0,
                    particular: "",
                    quantity: 0,
                    rate: 0,
                    total: 0,
                },
            };
        },

        watch: {
            value: {
                handler: function(newValue) {
                    this.row = newValue;
                    this.row.sn = this.index + 1;
                },
                immediate: true,
            },

            row: {
                handler: function() {
                    this.calculateTotal();
                    this.$emit("input", this.row);
                },
                deep: true,
            },
        },

        methods: {
            calculateTotal() {
                this.row.total = Number(this.row.quantity) * Number(this.row.rate);
            },
        },
    };
</script>

<style scoped>

</style>
